#include "secure.h"       // Header file with secure interface API
#include "../system_LPC55S69_cm33_core0.h"

typedef int (*NS_fp_getID)(void) __attribute__((cmse_nonsecure_call));

static unsigned char l, b[256];
static NS_fp_getID   fct_getID = NULL;

uint32_t GetSystemCoreClock(void)
{
    SystemCoreClockUpdate();
    return SystemCoreClock;
}

int init(NS_getID fctptr)
{
    fct_getID = (NS_fp_getID)fctptr;
    return 0;
}

int save(const unsigned char *data, unsigned char len)
{
    for (int i = 0; i < len; i++) b[i] = data[i];
    l = len;
    if (fct_getID != NULL) (void)fct_getID();
    for (int i = 0; i < 100000; i++) __asm("nop");
    return 0;
}

int restore(unsigned char *data)
{
    for (int i = 0; i < l; i++) data[i] = b[i];
    if (fct_getID != NULL) (void)fct_getID();
    for (int i = 0; i < 5000000; i++) __asm("nop");
    return l;
}
