/***********************************************************
*                       pC/OS 1.94b                        *
*                   a FREE - RTOS Kernel                   *
*                                                          *
*                 based on the C/OS 1.00                  *
*                   by  Jean J. Labrosse                   *
*                                                          *
*      changed by Frank Goetze  -  www.embedded-os.de      *
************************************************************
*                      OS_R32C_c.c                         *
*                 R32C111 Specific Code                    *
*                                                          *
***********************************************************/
#include "../../inc/pC_OS.h"
#include "../../inc/_private/pC_OS_internal.h"

/*
***********************************************************
*                    SETUP THE TASK STACK
***********************************************************
*/
OS_STK_TYPE *OSTaskInitStk(void (OS_FAR *task)(void *dptr), void *Tdata, void **pstk, U16 stksize) KC51_REENTRANT
{
    OS_STK_TYPE *stk, flag;

    // ---- HW specific ----
    stk      = &((OS_STK_TYPE *)*pstk)[stksize];          /* decrement first !                    */
    flag     = 0x00000040;
    stk      = (U32 *)pstk;                               /* decrement first !                    */
/*
    *--stk   = (U32)(Tdata);
    *--stk   = (U32)(task);
*/
    *--stk   = (U32)(flag);                               /* Flag register                        */
    *--stk   = (U32)(task);                               /* PC register                          */
    *--stk   = (U32)0xFBFBFBFBL;                          /* FB register                          */
    *--stk   = (U32)0x5B5B5B5BL;                          /* SB register                          */
    *--stk   = (U32)0xA3A3A3A3L;                          /* A3 register                          */
    *--stk   = (U32)0xA2A2A2A2L;                          /* A2 register                          */
    *--stk   = (U32)0xA1A1A1A1L;                          /* A1 register                          */
    #ifdef __IAR_SYSTEMS_ICC__
    *--stk   = (U32)(Tdata);
    #else
    *--stk   = (U32)0xA0A0A0A0L;                          /* A0 register                          */
    #endif
    *--stk   = (U32)0x77775555L;                          /* R7R5 register                        */
    *--stk   = (U32)0x66664444L;                          /* R6R4 register                        */
    *--stk   = (U32)0x33331111L;                          /* R3R1 register                        */
    *--stk   = (U32)0x22220000L;                          /* R2R0 register                        */
    // ---------------------
    // pstk is the descending end-of-stack and must not be updated
    return stk;
}
